<template>
  <el-form ref="form" :model="form" :rules="rules">
    <ele-pro-table
      ref="table"
      :needPage="false"
      :columns="columns"
      @columns-change="handleColumnChange"
      :cache-key="cacheKeyUrl"
      :datasource="form.datasource"
      class="time-form"
    >
      <!-- 表头工具栏 -->
      <template v-slot:toolbar>
        <div class="headbox" v-if="!contractId && isShowAdd">
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="handlAdd('', -1)"
          >
            新增
          </el-button>
        </div>
      </template>
      <template v-slot:technicalDrawings="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.technicalDrawings'"
        >
          <fileMain v-model="row.technicalDrawings" type="view"></fileMain>
        </el-form-item>
      </template>
      <template v-slot:industryArtFiles="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.industryArtFiles'"
        >
          <fileMain v-model="row.industryArtFiles" type="view"></fileMain>
        </el-form-item>
      </template>
      <template v-slot:otherFiles="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.otherFiles'"
        >
          <fileMain v-model="row.otherFiles" type="view"></fileMain>
        </el-form-item>
      </template>
      <template v-slot:customerReqFiles="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.customerReqFiles'"
        >
          <div v-if="row.customerReqFiles && row.customerReqFiles?.length">
            <el-link
              v-for="link in row.customerReqFiles"
              :key="link.id"
              type="primary"
              :underline="false"
              @click="downloadFile(link)"
            >
              {{ link.name }}
            </el-link>
          </div>
        </el-form-item>
      </template>

      <template v-slot:remark="{ row, $index }">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + $index + '.remark'"
        >
          <el-input
            clearable
            v-model="row.remark"
            type="textarea"
            placeholder="请输入"
          />
        </el-form-item>
      </template>
      <template v-slot:totalCount="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.totalCount'"
          :rules="[
            { required: true, message: '请输入发货数量', trigger: 'blur' }
          ]"
        >
          <el-input
            v-model="scope.row.totalCount"
            @input="(val) => changeNum(val, scope.row, scope.$index)"
          ></el-input>
        </el-form-item>
      </template>
      <template v-slot:singlePrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.singlePrice'"
        >
          <el-input
            v-model="scope.row.singlePrice"
            placeholder="请输入"
            @input="changeNum(val, scope.row, scope.$index)"
            type="number"
          >
            <template slot="append">元</template>
          </el-input>
        </el-form-item>
      </template>
      <template v-slot:notaxSinglePrice="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.notaxSinglePrice'"
        >
          <el-input
            v-model="scope.row.notaxSinglePrice"
            placeholder="请输入"
            type="number"
          >
            <template slot="append">元</template>
          </el-input>
        </el-form-item>
      </template>
      <template v-slot:warehouseId="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.warehouseId'"
          :rules="[{ required: true, message: '请选择仓库', trigger: 'blur' }]"
        >
          <el-select v-model="scope.row.warehouseId" placeholder="请选择">
            <el-option
              v-for="item in scope.row.warehouseList"
              :key="item.warehouseId"
              :label="item.warehouseName"
              :value="item.warehouseId"
              @click.native="warehouseChange(scope.$index, scope.row, item)"
            >
            </el-option>
          </el-select>
        </el-form-item>
      </template>
      <template v-slot:warehouseNum="scope">
        <el-form-item style="margin-bottom: 20px">
          {{ scope.row.warehouseNum }}
        </el-form-item>
      </template>
      <template v-slot:headerTotalCount="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:headerWarehouseId="{ column }">
        <span class="is-required">{{ column.label }}</span>
      </template>
      <template v-slot:taskName="scope">
        <el-form-item
          style="margin-bottom: 20px"
          :prop="'datasource.' + scope.$index + '.taskName'"
        >
          <el-input
            v-model="scope.row.taskName"
            placeholder="请选择"
            style="width: 60%; margin-right: 10px"
            disabled
          ></el-input>
          <el-button
            v-if="scope.row.productCode"
            size="small"
            type="primary"
            @click.native="handleTaskinstance(scope.row, scope.$index)"
            >选择
          </el-button>
        </el-form-item>
      </template>
      <!-- 操作列 -->
      <template v-slot:action="scope">
        <el-popconfirm
          class="ele-action"
          title="确定要删除吗？"
          @confirm="remove(scope.$index)"
        >
          <template v-slot:reference>
            <el-link type="danger" :underline="false" icon="el-icon-delete">
              删除
            </el-link>
          </template>
        </el-popconfirm>
      </template>
    </ele-pro-table>
    <product-list
      ref="productListRef"
      classType="1"
      :isGetInventoryTotal="true"
      @changeParent="changeParent"
    ></product-list>
    <taskinstance-dialog
      ref="taskinstanceDialogRef"
      v-if="taskinstanceDialogFlag"
      @saveTaskInstance="saveTaskInstance"
      :visible.sync="taskinstanceDialogFlag"
    ></taskinstance-dialog>
  </el-form>
</template>
<script>
  import { emailReg, phoneReg, numberReg } from 'ele-admin';
  import dictMixins from '@/mixins/dictMixins';
  // import productList from './product-list.vue';
  import productList from '@/BIZComponents/product-list.vue';
  import {
    getWarehouseOutStock,
    getIdWarehouseList
  } from '@/api/saleManage/saleorder';
  import taskinstanceDialog from '@/BIZComponents/procedure/taskinstanceDialog.vue';

  import tabMixins from '@/mixins/tableColumnsMixin';
  import { getFile } from '@/api/system/file';
  import fileMain from '@/components/addDoc/index.vue';
  import { getCode } from '@/components/addDoc/api/index.js';
  import { lbjtList } from '@/enum/dict.js';
  export default {
    mixins: [dictMixins,tabMixins],
    props: {
      orderId: String,
      isShowAdd: {
        type: Boolean,
        default: true
      },
      pricingWay: [Number, String],
      productType: ''
    },
    components: {
      fileMain,
      productList,taskinstanceDialog
    },
    data() {
      const defaultForm = {
        key: null,
        endTime: '',
        isFirst: 0,
        name: '',
        startTime: '',
        workHour: '',
        technicalDrawings: []
        // warehouseCode:"",
        // warehouseId:'',
        // warehouseName:'',
      };
      return {
        cacheKeyUrl:'eos-purchaseOrder-outSourceSend-inventoryTable',
        discountTotalPrice: 0.0,
        allPrice: 0.0,
        numberReg,
        defaultForm,
        taskinstanceDialogFlag:false,
        warehouseList: [],
        form: {
          datasource: []
        },
        rules: {},
        columns: [
          {
            width: 45,
            type: 'index',
            columnKey: 'index',
            align: 'center',
            fixed: 'left'
          },
          {
            minWidth: 200,
            prop: 'productName',
            label: '名称',
            slot: 'productName',
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'productCode',
            label: '编码',
            slot: 'productCode',
            align: 'center'
          },
          {
            minWidth: 150,
            prop: 'productCategoryName',
            label: '类型',
            slot: 'productCategoryName',
            align: 'center'
          },
          {
            minWidth: 100,
            prop: 'productBrand',
            label: '牌号',
            slot: 'productBrand',
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'modelType',
            label: '型号',
            slot: 'modelType',
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'specification',
            label: '规格',
            slot: 'specification',
            align: 'center'
          },
          {
            width: 120,
            prop: 'imgCode',
            align: 'center',
            label: '图号/件号',
            showOverflowTooltip: true
          },
          {
            width: 120,
            prop: 'produceType',
            align: 'center',
            label: '属性类型',
            showOverflowTooltip: true,
            formatter: (row, column) => {
              if (row.produceType) {
                return row.produceType
                  .map((item) => {
                    return lbjtList[item];
                  })
                  .toString();
              }
            }
          },
          // {
          //   width: 120,
          //   prop: 'approvalNumber',
          //   align: 'center',
          //   label: '批准文号',
          //   showOverflowTooltip: true
          // },
          {
            width: 120,
            prop: 'packingSpecification',
            align: 'center',
            label: '包装规格',
            showOverflowTooltip: true
          },
          {
            minWidth: 150,
            prop: 'supplierMark',
            label: '客户代号',
            slot: 'supplierMark',
            align: 'center'
          },
          {
            minWidth: 200,
            prop: 'warehouseId',
            label: '仓库名称',
            slot: 'warehouseId',
            headerSlot: 'headerWarehouseId',
            align: 'center'
          },
          {
            minWidth: 80,
            prop: 'warehouseNum',
            label: '库存',
            slot: 'warehouseNum',
            align: 'center'
          },
          {
            width: 100,
            prop: 'totalCount',
            label: '发货数量',
            slot: 'totalCount',
            headerSlot: 'headerTotalCount',
            align: 'center'
          },
          // {
          //   width: 120,
          //   prop: 'orderTotalCount',
          //   label: '总数量',
          //   slot: 'orderTotalCount'
          // },
          {
            minWidth: 300,
            prop: 'taskName',
            label: '工序',
            slot: 'taskName',
            align: 'center'
          },
          {
            width: 110,
            prop: 'batchNo',
            label: '批次号',
            slot: 'batchNo',
            align: 'center'
          },
          {
            minWidth: 100,
            prop: 'measuringUnit',
            label: '计量单位',
            slot: 'measuringUnit',
            align: 'center'
          },
          {
            width: 120,
            prop: 'singleWeight',
            label: '单重',
            slot: 'singleWeight',
            align: 'center'
          },
          {
            width: 100,
            prop: 'sendTotalWeight',
            label: '发货总重',
            slot: 'sendTotalWeight',
            align: 'center'
          },
          {
            width: 100,
            prop: 'weightUnit',
            label: '重量单位',
            slot: 'weightUnit',
            align: 'center'
          },
          {
            width: 160,
            prop: 'pricingWay',
            label: '计价方式',
            slot: 'pricingWay',
            align: 'center',
            formatter: (row, column) => {
              return row.pricingWay == 1
                ? '数量'
                : row.pricingWay == 2
                ? '重量'
                : '';
            }
          },
          {
            width: 190,
            prop: 'singlePrice',
            label: '单价',
            slot: 'singlePrice',
            align: 'center'
          },
          {
            width: 120,
            prop: 'taxRate',
            label: '税率',
            formatter: (_row, _column, cellValue) => {
              return _row.taxRate ? _row.taxRate + '%' : '';
            },
            align: 'center'
          },
          {
            width: 180,
            prop: 'notaxSinglePrice',
            label: '不含税单价',
            slot: 'notaxSinglePrice',
            align: 'center'
          },
          {
            width: 100,
            prop: 'discountSinglePrice',
            label: '折让单价',
            slot: 'discountSinglePrice',
            align: 'center',
            formatter: (_row, _column, cellValue) => {
              return _row.discountSinglePrice
                ? Number(_row.discountSinglePrice).toFixed(2)
                : '';
            }
          },
          {
            width: 80,
            prop: 'totalPrice',
            label: '合计',
            slot: 'totalPrice',
            align: 'center'
          },
          {
            width: 100,
            prop: 'discountTotalPrice',
            label: '折让合计',
            slot: 'discountTotalPrice',
            align: 'center',
            formatter: (_row, _column, cellValue) => {
              return _row.discountTotalPrice
                ? Number(_row.discountTotalPrice).toFixed(2)
                : '';
            }
          },

          {
            prop: 'provenance',
            label: '产地',
            slot: 'provenance',
            align: 'center',
            minWidth: 200,
            showOverflowTooltip: true,
            formatter: (row, column) => {
              return row.provenance && row.provenance.length
                ? row.provenance
                    .map((item) => this.getDictValue('产地', item))
                    .join(',')
                : '';
            }
          },
          {
            minWidth: 140,
            prop: 'customerExpectDeliveryDeadline',
            label: '客户期望交期',
            slot: 'customerExpectDeliveryDeadline',
            headerSlot: 'headerCustomerExpectDeliveryDeadline',
            align: 'center'
          },
          {
            minWidth: 140,
            prop: 'produceDeliveryDeadline',
            label: '生产交付交期',
            slot: 'produceDeliveryDeadline',
            align: 'center'
          },
          {
            width: 100,
            prop: 'guaranteePeriod',
            label: '质保期',
            slot: 'guaranteePeriod',
            formatter: (_row, _column, cellValue) => {
              let val = '';
              if (_row.guaranteePeriod) {
                val += _row.guaranteePeriod;
              }
              if (_row.guaranteePeriodUnitName) {
                val += _row.guaranteePeriodUnitName;
              }
            },
            align: 'center'
          },
          {
            minWidth: 120,
            prop: 'guaranteePeriodDeadline',
            label: '质保截止日期',
            align: 'center'
          },
          {
            minWidth: 200,
            prop: 'customerReqFiles',
            label: '客户需求',
            slot: 'customerReqFiles',
            align: 'center'
          },
          {
            width: 130,
            prop: 'technicalAnswerName',
            label: '技术答疑人',
            slot: 'technicalAnswerName',
            align: 'center'
          },
          {
            width: 220,
            prop: 'technicalParams',
            label: '技术参数',
            slot: 'technicalParams',
            align: 'center'
          },
          {
            width: 240,
            prop: 'technicalDrawings',
            label: '技术图纸',
            slot: 'technicalDrawings',
            align: 'center'
          },
          {
            width: 240,
            prop: 'industryArtFiles',
            label: '工艺附件',
            slot: 'industryArtFiles',
            align: 'center'
          },
          {
            width: 240,
            prop: 'otherFiles',
            label: '其他附件',
            slot: 'otherFiles',
            align: 'center'
          },
          {
            width: 220,
            prop: 'remark',
            label: '备注',
            slot: 'remark',
            align: 'center'
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 120,
            align: 'center',
            resizable: false,
            slot: 'action',
            fixed: 'right',
            showOverflowTooltip: true
          }
        ]
      };
    },
    created() {
      this.requestDict('产地');
      this.requestDict('生产类型');
      // getWarehouseList().then((res) => {
      //   this.warehouseList = res;
      // });
    },
    computed: {
      canHandl() {
        return this.form.datasource.length;
      },
      contractId() {
        return this.$store.state.order.contractId;
      }
    },
    methods: {
      downloadFile(file) {
        getFile({ objectName: file.storePath }, file.name);
      },
      async warehouseChange(index, row, item) {
        console.log(item, 'row');

        this.$set(
          this.form.datasource[index],
          'warehouseName',
          item.warehouseName
        );
        this.$set(
          this.form.datasource[index],
          'warehouseCode',
          item.warehouseCode || 0
        );
        const warehouseOutStock = await getWarehouseOutStock({
          warehouseId: item.warehouseId,
          code: row.productCode
        });
        this.$set(
          this.form.datasource[index],
          'warehouseNum',
          warehouseOutStock
        );
      },
      handleTaskinstance(row, index) {
        this.taskinstanceDialogFlag = true;
        this.$nextTick(() => {
          this.$refs.taskinstanceDialogRef.open(row, index);
        });
      },
      //修改数量更新合计
      changeNum(val, row, index) {
        this.$set(
          this.form.datasource[index],
          'sendTotalWeight',
          val ? val * row.singleWeight : ''
        );
        this.$set(
          this.form.datasource[index],
          'totalPrice',
          this.getTotalPrice(row).toFixed(2)
        );
        this.$set(
          this.form.datasource[index],
          'discountTotalPrice',
          this.getDiscountTotalPrice(row).toFixed(2)
        );
      },
      getTotalPrice(row) {
        let num = 0;
        if (row.pricingWay == 1) {
          num = Number(row.singlePrice) * Number(row.totalCount);
        }
        if (row.pricingWay == 2) {
          num =
            Number(row.singlePrice) *
            Number(row.totalCount) *
            Number(row.singleWeight);
        }

        return num;
      },
      getDiscountTotalPrice(row) {
        let num = 0;
        if (row.pricingWay == 1) {
          num = Number(row.discountSinglePrice) * Number(row.totalCount);
        }
        if (row.pricingWay == 2) {
          num =
            Number(row.discountSinglePrice) *
            Number(row.totalCount) *
            Number(row.singleWeight);
        }

        return num;
      },
      // //选择产品回调
      // changeParent(obj, idx) {
      //   obj.orderTotalCount = obj.totalCount;
      //   obj.id = '';
      //   this.$set(
      //     this.form.datasource,
      //     this.form.datasource.length,
      //     copyObj(obj)
      //   );
      // },

      //选择产品回调
      changeParent(obj = [], idx) {
        obj.forEach(async (item, index) => {
          let i = idx == -1 ? index : idx;
          let row = JSON.parse(JSON.stringify(this.defaultForm));
          row.key = this.form.datasource.length + 1;
          let parasm = idx == -1 ? row : this.form.datasource[i];
          this.$set(parasm, 'productId', item.id);
          this.$set(parasm, 'categoryName', item.name);
          this.$set(parasm, 'productCategoryId', item.categoryLevelId);
          this.$set(parasm, 'productBrand', item.brandNum);
          this.$set(parasm, 'productCategoryName', item.categoryLevelPath);
          this.$set(parasm, 'productCode', item.code);
          this.$set(parasm, 'productName', item.name);
          this.$set(parasm, 'modelType', item.modelType);
          this.$set(parasm, 'availableCountBase', item.availableCountBase);
          this.$set(parasm, 'measuringUnit', item.measuringUnit);
          this.$set(parasm, 'specification', item.specification);
          this.$set(parasm, 'weightUnit', item.weightUnit);
          this.$set(parasm, 'imgCode', item.imgCode);
          this.$set(parasm, 'produceType', item.componentAttribute);
          this.$set(parasm, 'approvalNumber', item.extField?.approvalNumber);
          this.$set(parasm, 'singleWeight', item.netWeight);
          this.$set(parasm, 'pricingWay', item.pricingWay || 1);
          this.$set(parasm, 'singlePrice', 0);
          this.$set(parasm, 'discountSinglePrice', 0);

          this.$set(
            parasm,
            'warehouseList',
            await getIdWarehouseList({
              categoryId: item.id
            })
          );
          this.$set(
            parasm,
            'packingSpecification',
            item.extField?.packingSpecification
          );
          this.$set(
            parasm,
            'supplierMark',
            this.form.datasource[0]?.supplierMark
          );
          this.$set(parasm, 'batchNo', await getCode('1900101420390125570'));
          if (item.purchaseOrigins?.length > 0) {
            item.purchaseOrigins = item.purchaseOrigins.map((val) => val + '');
          }
          this.$set(parasm, 'provenance', item.purchaseOrigins || []);
          if (idx == -1) {
            this.form.datasource.push(row);
          }
        });
      },
      saveTaskInstance(row = {}) {
        this.$set(this.form.datasource[row.index], 'taskId', row.id);
        this.$set(this.form.datasource[row.index], 'taskName', row.name);
        this.$set(
          this.form.datasource[row.index],
          'routingId',
          row.produceRoutingId
        );
      },
      validateTotalCount(row) {
        return (rule, value, callback) => {
          if (isNaN(value) || Number(value) <= 0) {
            this.$message.error('请输入大于0的数');
            callback(new Error('请输入大于0的数字'));
          } else if (Number(value) > row.orderTotalCount) {
            this.$message.error('输入的数字不能大于最大发货值');
            callback(new Error('输入的数字不能大于最大发货值'));
          } else {
            callback();
          }
        };
      },
      // 返回列表数据
      getTableValue() {
        let comitDatasource = this.form.datasource;
        if (comitDatasource.length === 0) return [];
        comitDatasource.forEach(async (v) => {
          v.totalCount = Number(v.totalCount);
          v.technicalDrawings = Array.isArray(v.technicalDrawings)
            ? v.technicalDrawings
            : [];
          v.customerReqFiles = Array.isArray(v.customerReqFiles)
            ? v.customerReqFiles
            : [];
          v.industryArtFiles = v.industryArtFiles || [];
          v.otherFiles = v.otherFiles || [];
          // v.ownerId = this.warehouseList.find(item => v.warehouseId == item.id)?.ownerId 获取仓库人员id
        });
        return comitDatasource;
      },
      getPrice() {
        return [this.allPrice];
      },

      //修改回显
      putTableValue(data) {
        if (data) {
          this.form.datasource = data;
          data.forEach(async (item, index) => {
            if (item.warehouseId) {
              this.$set(
                this.form.datasource[index],
                'warehouseNum',
                await getWarehouseOutStock({
                  warehouseId: item.warehouseId,
                  code: item.productCode
                })
              );
            }
            this.$set(
              this.form.datasource[index],
              'warehouseList',
              await getIdWarehouseList({
                categoryId: item.productId
              })
            );
            if (!item.sendTotalWeight)
              this.$set(
                item,
                'sendTotalWeight',
                Number(item.totalCount) * Number(item.singleWeight)
              );
          });
        }
      },

      remove(i) {
        this.form.datasource.splice(i, 1);
        this.setSort();
      },
      // 清空表格
      restTable() {
        this.form.datasource = [];
      },
      // 重新排序
      setSort() {
        this.form.datasource.forEach((n, index) => {
          n.key = index + 1;
        });
      },
      // 添加
      handlAdd(item, index) {
        if (!this.orderId) return this.$message.error('请先选择订单');
        this.$refs.productListRef.open(item, index);
      },

      validateForm(callback) {
        //开始表单校验
        this.$refs.form.validate((valid, obj) => {
          if (obj) {
            let messages = Object.keys(obj).map((key) => obj[key][0]);
            if (messages.length > 0) {
              this.$message.warning(messages[0].message);
            }
          }
          callback(valid);
        });
      }
    }
  };
</script>
<style lang="scss" scoped>
  .headbox {
    display: flex;
    justify-content: space-between;
    align-items: center;

    .amount {
      font-size: 14px;
      font-weight: bold;
      padding-right: 30px;
    }
  }

  .time-form .el-form-item {
    margin-bottom: 0 !important;
  }

  ::v-deep .period {
    display: flex;

    .borderleftnone {
      .el-input--medium .el-input__inner {
        border-top-right-radius: 0;
        border-bottom-right-radius: 0;
      }
    }

    .borderrightnone {
      .el-input--medium .el-input__inner {
        border-top-left-radius: 0;
        border-bottom-left-radius: 0;
      }
    }
  }

  ::v-deep .time-form tbody > tr:hover > td {
    background-color: transparent !important;
  }

  ::v-deep .time-form .el-table tr {
    background-color: #ffffff;
  }

  .pricebox {
    display: flex;
    justify-content: flex-start;
    align-items: center;
    font-weight: bold;
  }
</style>
